<template>
  <div class="data-info-box card mt-3">
    <a data-toggle="collapse"
       :href="`#dist-${collapseId}`"
       v-if="collapse">
      <div class="card-header">
        <h6 class="card-title text-dark">{{ title || 'no title given' }}</h6>
      </div>
    </a>
    <h6 class="card-header"
         v-if="!collapse"
         @click="$router.push({ path: linkTo})">
      <span class="card-title text-dark">{{ title || 'no title given' }}</span>
    </h6>


    <div class="card-body" :class="{'collapse': collapse}" :id="`dist-${collapseId}`"
         @click="$router.push({ path: linkTo })">
      <div class="row">
        <div class="col-2" v-if="bodyImg">
          <img class="body-img card-img" ref="bodyImg" :src="bodyImg" alt="Body Info Box Image">
        </div>
        <div :class="{'col-12 col-md-12': !bodyImg && !metadata,
                      'col-12 col-md-10': bodyImg && !metadata,
                      'col-12 col-md-7': bodyImg && metadata,
                      'col-12 col-md-9': !bodyImg && metadata}
                      ">
          <p class="card-text" v-if="!isNil(description)">{{ truncate(description, descriptionLength) }}</p>
        </div>
        <div class="col-12 col-md-3" v-if="!isNil(metadata) && isObject(metadata)">
          <span class="formats badge badge-secondary mr-1"
                v-for="(tag, i) in bodyTags"
                v-if="showDistributionFormat(tag)"
                :key="i"
                :type="tag.title">
          {{ truncate(tag.title, 8, true) }}
          </span>
          <dl class="small"
              v-for="(md, i) in metadata"
              :key="i"
              v-if="has(md, 'title') && !isNil(md.title) && has(md, 'value')">
            <dt>{{ md.title }}</dt>
            <dd>{{ md.value }}</dd>
          </dl>
        </div>
      </div>
    </div>

    <div class="card-footer d-flex justify-content-between">
      <linkCopyBar :link="footerLink" v-if="hasFooterLink()"/>
      <span class="align-middle mr-1"
            v-for="(tag, index) in footerTags"
            :key="index">
          <span class="badge badge-secondary">{{ tag }}</span>
      </span>
      <span class="align-middle mr-1" v-if="!isEmpty(source)">
        <img class="pr-1" width="30" alt="Catalogue Flag" v-if="has(source, 'sourceImage')" :src="source.sourceImage">
        <small v-if="has(source, 'sourceTitle') && !isNil(source.sourceTitle)">{{ getTranslationFor(source.sourceTitle, $i18n.locale, []) }}</small>
      </span>
      <!--TODO: Display indicators in same row as linkCopyBar -->
      <i class="material-icons feature-icon float-right" v-for="(fi, index) in featureIndicators" :key="index">{{ fi }}</i>
    </div>
  </div>
</template>

<script>
  /* eslint-disable space-infix-ops,no-mixed-operators */
  import {
    has,
    isNil,
    isEmpty,
    isObject,
  } from 'lodash';
  import LinkCopyBar from './LinkCopyBar';
  import animations from '../mixins/animations';
  import { getTranslationFor, truncate } from '../utils/helpers';

  export default {
    name: 'dataInfoBox',
    components: {
      linkCopyBar: LinkCopyBar,
    },
    props: {
      collapse: {
        type: Boolean,
        default: false,
      },
      collapseId: {
        type: Number,
      },
      linkTo: {
        type: String,
      },
      title: {
        type: String,
        default: 'pass a title property, please',
      },
      description: {
        type: String,
      },
      descriptionLength: {
        type: Number,
        default: 100,
      },
      metadata: {
        type: Object,
      },
      bodyTags: {
        type: Array,
        default: () => [],
      },
      bodyImg: {
      },
      source: {
        type: Object,
      },
      footerTags: {
        type: Array,
        default: () => [],
      },
      /** link: {title: 'MyTitle', url: 'MyLink', target: '_blank'} */
      footerLink: {
        type: Object,
        default: () => {},
      },
      featureIndicators: {
        type: Array,
        default: () => [],
      },
    },
    mixins: [animations],
    data() {
      return {};
    },
    computed: {},
    methods: {
      has,
      isNil,
      isEmpty,
      isObject,
      getTranslationFor,
      truncate,
      hasFooterLink() {
        return Boolean(this.footerLink) && Object.prototype.hasOwnProperty.call(this.footerLink, 'url');
      },
      showDistributionFormat(tag) {
        return has(tag, 'title') && !isNil(tag.title);
      },
      pathEndsWithSlash(path) {
        return (path.slice(-1) === '/');
      },
    },
    created() {
    },
    mounted() {
      // this.fade('.data-info-box.fade-animation');
      // this.swingDown('.data-info-box.swing-down-animation');
      // this.pointExpansion('.data-info-box');
      // this.randomSideEnter('.data-info-box');
    },
    beforeDestroy() {
    },
  };
</script>

<style lang="scss" scoped>
  @import '../styles/bootstrap_theme';

  // Truncated description text
  .truncated-gradient {
    height: 100%;
    max-height: 10rem;
    overflow: hidden;
    position: relative;
    &:after {
      content: "";
      position: absolute;
      bottom: 0;
      left: 0;
      background: linear-gradient(to bottom, rgba(255, 255, 255, 0), rgba(255, 255, 255, 1));
      height: 4rem;
      width: 100%;
    }
  }

  .data-info-box {
    border-left: 3px solid rgba($primary, .8);
    box-shadow: 0 1px 3px rgba(0, 0, 0, 0.12), 0 1px 2px rgba(0, 0, 0, 0.24);
    transition: all .3s cubic-bezier(.25, .8, .25, 1);
    &:hover {
      border-left: 3px solid rgba($primary, 1.0);
      box-shadow: 0 8px 16px rgba(0, 0, 0, 0.25), 0 4px 8px rgba(0, 0, 0, 0.22);
      cursor: pointer;
    }

    .formats {
      &[type="HTML"] {
        background-color: #55a1ce;
      }
      &[type="JSON"] {
        background-color: #ef7100;
      }
      &[type="XML"] {
        background-color: #ef7100;
      }
      &[type="TXT"] {
        background-color: #74cbec;
      }
      &[type="CSV"] {
        background-color: #dfb100;
      }
      &[type="XLS"] {
        background-color: #2db55d;
      }
      &[type="ZIP"] {
        background-color: #686868;
      }
      &[type="API"] {
        background-color: #ec96be;
      }
      &[type="PDF"] {
        background-color: #e0051e;
      }
      &[type="RDF"],
      &[type="NQUAD"],
      &[type="NTRIPLES"],
      &[type="TURTLE"] {
        background-color: #0b4498;
      }
    }

    .card-footer {
      display:flex;
      flex-direction: row;
      justify-content: space-between;

      i {
        font-size: 32px;
        vertical-align: middle;
        margin: 0 0 .1em 0;
      }
    }
  }
</style>
